Package org.apache.commons.compress.archivers.tar

# Class TarUtils

java.lang.Object
org.apache.commons.compress.archivers.tar.TarUtils

public class TarUtils extends Object
This class provides static utility methods to work with byte streams.

This class is immutable

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static long`
  `computeCheckSum(byte[] buf)`
  Computes the checksum of a tar entry header.
  `static int`
  `formatCheckSumOctalBytes(long value, byte[] buf, int offset, int length)`
  Writes an octal value into a buffer.
  `static int`
  `formatLongOctalBytes(long value, byte[] buf, int offset, int length)`
  Writes an octal long integer into a buffer.
  `static int`
  `formatLongOctalOrBinaryBytes(long value, byte[] buf, int offset, int length)`
  Writes a long integer into a buffer as an octal string if this will fit, or as a binary number otherwise.
  `static int`
  `formatNameBytes(String name, byte[] buf, int offset, int length)`
  Copies a name into a buffer.
  `static int`
  `formatNameBytes(String name, byte[] buf, int offset, int length, ZipEncoding encoding)`
  Copies a name into a buffer.
  `static int`
  `formatOctalBytes(long value, byte[] buf, int offset, int length)`
  Writes an octal integer into a buffer.
  `static void`
  `formatUnsignedOctalString(long value, byte[] buffer, int offset, int length)`
  Fills a buffer with unsigned octal number, padded with leading zeroes.
  `static boolean`
  `parseBoolean(byte[] buffer, int offset)`
  Parses a boolean byte from a buffer.
  `protected static List<TarArchiveStructSparse>`
  `parseFromPAX01SparseHeaders(String sparseMap)`
  For PAX Format 0.1, the sparse headers are stored in a single variable : GNU.sparse.map GNU.sparse.map Map of non-null data chunks.
  `static String`
  `parseName(byte[] buffer, int offset, int length)`
  Parses an entry name from a buffer.
  `static String`
  `parseName(byte[] buffer, int offset, int length, ZipEncoding encoding)`
  Parses an entry name from a buffer.
  `static long`
  `parseOctal(byte[] buffer, int offset, int length)`
  Parses an octal string from a buffer.
  `static long`
  `parseOctalOrBinary(byte[] buffer, int offset, int length)`
  Computes the value contained in a byte buffer.
  `protected static List<TarArchiveStructSparse>`
  `parsePAX01SparseHeaders(String sparseMap)`
  Deprecated.
  use #parseFromPAX01SparseHeaders instead
  `protected static List<TarArchiveStructSparse>`
  `parsePAX1XSparseHeaders(InputStream inputStream, int recordSize)`
  For PAX Format 1.X: The sparse map itself is stored in the file data block, preceding the actual file data.
  `protected static Map<String,String>`
  `parsePaxHeaders(InputStream inputStream, List<TarArchiveStructSparse> sparseHeaders, Map<String,String> globalPaxHeaders)`
  Deprecated.
  use the four-arg version instead
  `protected static Map<String,String>`
  `parsePaxHeaders(InputStream inputStream, List<TarArchiveStructSparse> sparseHeaders, Map<String,String> globalPaxHeaders, long headerSize)`
  For PAX Format 0.0, the sparse headers(GNU.sparse.offset and GNU.sparse.numbytes) may appear multi times, and they look like:
  `static TarArchiveStructSparse`
  `parseSparse(byte[] buffer, int offset)`
  Parses the content of a PAX 1.0 sparse block.
  `static boolean`
  `verifyCheckSum(byte[] header)`
  Wikipedia says: The checksum is calculated by taking the sum of the unsigned byte values of the header block with the eight checksum bytes taken to be ASCII spaces (decimal value 32).

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### computeCheckSum

    public static long computeCheckSum(byte[] buf)
    Computes the checksum of a tar entry header.
    Parameters:
      `buf` - The tar entry's header buffer.
    Returns:
      The computed checksum.

  - ### formatCheckSumOctalBytes

    public static int formatCheckSumOctalBytes(long value, byte[] buf, int offset, int length)
    Writes an octal value into a buffer. Uses `formatUnsignedOctalString(long, byte[], int, int)` to format the value as an octal string with leading zeros. The converted number is followed by NUL and then space.
    Parameters:
      `value` - The value to convert
      `buf` - The destination buffer
      `offset` - The starting offset into the buffer.
      `length` - The size of the buffer.
    Returns:
      The updated value of offset, i.e. offset+length
    Throws:
      `IllegalArgumentException` - if the value (and trailer) will not fit in the buffer

  - ### formatLongOctalBytes

    public static int formatLongOctalBytes(long value, byte[] buf, int offset, int length)
    Writes an octal long integer into a buffer. Uses `formatUnsignedOctalString(long, byte[], int, int)` to format the value as an octal string with leading zeros. The converted number is followed by a space.
    Parameters:
      `value` - The value to write as octal
      `buf` - The destinationbuffer.
      `offset` - The starting offset into the buffer.
      `length` - The length of the buffer
    Returns:
      The updated offset
    Throws:
      `IllegalArgumentException` - if the value (and trailer) will not fit in the buffer

  - ### formatLongOctalOrBinaryBytes

    public static int formatLongOctalOrBinaryBytes(long value, byte[] buf, int offset, int length)
    Writes a long integer into a buffer as an octal string if this will fit, or as a binary number otherwise. Uses `formatUnsignedOctalString(long, byte[], int, int)` to format the value as an octal string with leading zeros. The converted number is followed by a space.
    Parameters:
      `value` - The value to write into the buffer.
      `buf` - The destination buffer.
      `offset` - The starting offset into the buffer.
      `length` - The length of the buffer.
    Returns:
      The updated offset.
    Throws:
      `IllegalArgumentException` - if the value (and trailer) will not fit in the buffer.
    Since:
      1.4

  - ### formatNameBytes

    public static int formatNameBytes(String name, byte[] buf, int offset, int length)
    Copies a name into a buffer. Copies characters from the name into the buffer starting at the specified offset. If the buffer is longer than the name, the buffer is filled with trailing NULs. If the name is longer than the buffer, the output is truncated.
    Parameters:
      `name` - The header name from which to copy the characters.
      `buf` - The buffer where the name is to be stored.
      `offset` - The starting offset into the buffer
      `length` - The maximum number of header bytes to copy.
    Returns:
      The updated offset, i.e. offset + length

  - ### formatNameBytes

    public static int formatNameBytes(String name, byte[] buf, int offset, int length, ZipEncoding encoding) throws IOException
    Copies a name into a buffer. Copies characters from the name into the buffer starting at the specified offset. If the buffer is longer than the name, the buffer is filled with trailing NULs. If the name is longer than the buffer, the output is truncated.
    Parameters:
      `name` - The header name from which to copy the characters.
      `buf` - The buffer where the name is to be stored.
      `offset` - The starting offset into the buffer
      `length` - The maximum number of header bytes to copy.
      `encoding` - name of the encoding to use for file names
    Returns:
      The updated offset, i.e. offset + length
    Throws:
      `IOException` - on error
    Since:
      1.4

  - ### formatOctalBytes

    public static int formatOctalBytes(long value, byte[] buf, int offset, int length)
    Writes an octal integer into a buffer. Uses `formatUnsignedOctalString(long, byte[], int, int)` to format the value as an octal string with leading zeros. The converted number is followed by space and NUL
    Parameters:
      `value` - The value to write
      `buf` - The buffer to receive the output
      `offset` - The starting offset into the buffer
      `length` - The size of the output buffer
    Returns:
      The updated offset, i.e. offset+length
    Throws:
      `IllegalArgumentException` - if the value (and trailer) will not fit in the buffer

  - ### formatUnsignedOctalString

    public static void formatUnsignedOctalString(long value, byte[] buffer, int offset, int length)
    Fills a buffer with unsigned octal number, padded with leading zeroes.
    Parameters:
      `value` - number to convert to octal - treated as unsigned
      `buffer` - destination buffer
      `offset` - starting offset in buffer
      `length` - length of buffer to fill
    Throws:
      `IllegalArgumentException` - if the value will not fit in the buffer

  - ### parseBoolean

    public static boolean parseBoolean(byte[] buffer, int offset)
    Parses a boolean byte from a buffer. Leading spaces and NUL are ignored. The buffer may contain trailing spaces or NULs.
    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
    Returns:
      The boolean value of the bytes.
    Throws:
      `IllegalArgumentException` - if an invalid byte is detected.

  - ### parseFromPAX01SparseHeaders

    protected static List<TarArchiveStructSparse> parseFromPAX01SparseHeaders(String sparseMap) throws IOException
    For PAX Format 0.1, the sparse headers are stored in a single variable : GNU.sparse.map GNU.sparse.map Map of non-null data chunks. It is a string consisting of comma-separated values "offset,size[,offset-1,size-1...]"
    Parameters:
      `sparseMap` - the sparse map string consisting of comma-separated values "offset,size[,offset-1,size-1...]"
    Returns:
      unmodifiable list of sparse headers parsed from sparse map
    Throws:
      `IOException` - Corrupted TAR archive.
    Since:
      1.21

  - ### parseName

    public static String parseName(byte[] buffer, int offset, int length)
    Parses an entry name from a buffer. Parsing stops when a NUL is found or the buffer length is reached.
    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
      `length` - The maximum number of bytes to parse.
    Returns:
      The entry name.

  - ### parseName

    public static String parseName(byte[] buffer, int offset, int length, ZipEncoding encoding) throws IOException
    Parses an entry name from a buffer. Parsing stops when a NUL is found or the buffer length is reached.
    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
      `length` - The maximum number of bytes to parse.
      `encoding` - name of the encoding to use for file names
    Returns:
      The entry name.
    Throws:
      `IOException` - on error
    Since:
      1.4

  - ### parseOctal

    public static long parseOctal(byte[] buffer, int offset, int length)
    Parses an octal string from a buffer.

    Leading spaces are ignored. The buffer must contain a trailing space or NUL, and may contain an additional trailing space or NUL.

    The input buffer is allowed to contain all NULs, in which case the method returns 0L (this allows for missing fields).

    To work-around some tar implementations that insert a leading NUL this method returns 0 if it detects a leading NUL since Commons Compress 1.4.

    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
      `length` - The maximum number of bytes to parse - must be at least 2 bytes.
    Returns:
      The long value of the octal string.
    Throws:
      `IllegalArgumentException` - if the trailing space/NUL is missing or if an invalid byte is detected.

  - ### parseOctalOrBinary

    public static long parseOctalOrBinary(byte[] buffer, int offset, int length)
    Computes the value contained in a byte buffer. If the most significant bit of the first byte in the buffer is set, this bit is ignored and the rest of the buffer is interpreted as a binary number. Otherwise, the buffer is interpreted as an octal number as per the parseOctal function above.
    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
      `length` - The maximum number of bytes to parse.
    Returns:
      The long value of the octal or binary string.
    Throws:
      `IllegalArgumentException` - if the trailing space/NUL is missing or an invalid byte is detected in an octal number, or if a binary number would exceed the size of a signed long 64-bit integer.
    Since:
      1.4

  - ### parsePAX01SparseHeaders

    @Deprecated protected static List<TarArchiveStructSparse> parsePAX01SparseHeaders(String sparseMap)
    Deprecated.
    use #parseFromPAX01SparseHeaders instead
    For PAX Format 0.1, the sparse headers are stored in a single variable : GNU.sparse.map

    GNU.sparse.map: Map of non-null data chunks. It is a string consisting of comma-separated values "offset,size[,offset-1,size-1...]"

    Will internally invoke `parseFromPAX01SparseHeaders(java.lang.String)` and map IOExceptions to a RzuntimeException, You should use `parseFromPAX01SparseHeaders(java.lang.String)` directly instead.

    Parameters:
      `sparseMap` - the sparse map string consisting of comma-separated values "offset,size[,offset-1,size-1...]"
    Returns:
      sparse headers parsed from sparse map

  - ### parsePAX1XSparseHeaders

    protected static List<TarArchiveStructSparse> parsePAX1XSparseHeaders(InputStream inputStream, int recordSize) throws IOException
    For PAX Format 1.X: The sparse map itself is stored in the file data block, preceding the actual file data. It consists of a series of decimal numbers delimited by newlines. The map is padded with nulls to the nearest block boundary. The first number gives the number of entries in the map. Following are map entries, each one consisting of two numbers giving the offset and size of the data block it describes.
    Parameters:
      `inputStream` - parsing source.
      `recordSize` - The size the TAR header
    Returns:
      sparse headers
    Throws:
      `IOException` - if an I/O error occurs.

  - ### parsePaxHeaders

    @Deprecated protected static Map<String,String> parsePaxHeaders(InputStream inputStream, List<TarArchiveStructSparse> sparseHeaders, Map<String,String> globalPaxHeaders) throws IOException
    Deprecated.
    use the four-arg version instead
    For PAX Format 0.0, the sparse headers(GNU.sparse.offset and GNU.sparse.numbytes) may appear multi times, and they look like:

         GNU.sparse.size=size
         GNU.sparse.numblocks=numblocks
         repeat numblocks times
           GNU.sparse.offset=offset
           GNU.sparse.numbytes=numbytes
         end repeat

    For PAX Format 0.1, the sparse headers are stored in a single variable: GNU.sparse.map

    GNU.sparse.map: Map of non-null data chunks. It is a string consisting of comma-separated values "offset,size[,offset-1,size-1...]"

    Parameters:
      `inputStream` - input stream to read keys and values
      `sparseHeaders` - used in PAX Format 0.0 & 0.1, as it may appear multiple times, the sparse headers need to be stored in an array, not a map
      `globalPaxHeaders` - global PAX headers of the tar archive
    Returns:
      map of PAX headers values found inside the current (local or global) PAX headers tar entry.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### parsePaxHeaders

    protected static Map<String,String> parsePaxHeaders(InputStream inputStream, List<TarArchiveStructSparse> sparseHeaders, Map<String,String> globalPaxHeaders, long headerSize) throws IOException
    For PAX Format 0.0, the sparse headers(GNU.sparse.offset and GNU.sparse.numbytes) may appear multi times, and they look like:

         GNU.sparse.size=size
         GNU.sparse.numblocks=numblocks
         repeat numblocks times
           GNU.sparse.offset=offset
           GNU.sparse.numbytes=numbytes
         end repeat

    For PAX Format 0.1, the sparse headers are stored in a single variable : GNU.sparse.map

    GNU.sparse.map: Map of non-null data chunks. It is a string consisting of comma-separated values "offset,size[,offset-1,size-1...]"

    Parameters:
      `inputStream` - input stream to read keys and values
      `sparseHeaders` - used in PAX Format 0.0 & 0.1, as it may appear multiple times, the sparse headers need to be stored in an array, not a map
      `globalPaxHeaders` - global PAX headers of the tar archive
      `headerSize` - total size of the PAX header, will be ignored if negative
    Returns:
      map of PAX headers values found inside the current (local or global) PAX headers tar entry.
    Throws:
      `IOException` - if an I/O error occurs.
    Since:
      1.21

  - ### parseSparse

    public static TarArchiveStructSparse parseSparse(byte[] buffer, int offset)
    Parses the content of a PAX 1.0 sparse block.
    Parameters:
      `buffer` - The buffer from which to parse.
      `offset` - The offset into the buffer from which to parse.
    Returns:
      a parsed sparse struct
    Since:
      1.20

  - ### verifyCheckSum

    public static boolean verifyCheckSum(byte[] header)
    Wikipedia says:

    > The checksum is calculated by taking the sum of the unsigned byte values of the header block with the eight checksum bytes taken to be ASCII spaces (decimal value 32). It is stored as a six digit octal number with leading zeroes followed by a NUL and then a space. Various implementations do not adhere to this format. For better compatibility, ignore leading and trailing whitespace, and get the first six digits. In addition, some historic tar implementations treated bytes as signed. Implementations typically calculate the checksum both ways, and treat it as good if either the signed or unsigned sum matches the included checksum.

    The return value of this method should be treated as a best-effort heuristic rather than an absolute and final truth. The checksum verification logic may well evolve over time as more special cases are encountered.

    Parameters:
      `header` - tar header
    Returns:
      whether the checksum is reasonably good
    Since:
      1.5
    See Also:
      - COMPRESS-191